// Compiled by ClojureScript 1.9.562 {}
goog.provide('sablono.core');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('goog.string');
goog.require('sablono.normalize');
goog.require('sablono.util');
goog.require('sablono.interpreter');
goog.require('goog.dom');
/**
 * Add an optional attribute argument to a function that returns a element vector.
 */
sablono.core.wrap_attrs = (function sablono$core$wrap_attrs(func){
return (function() { 
var G__37339__delegate = function (args){
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,args))){
var vec__37336 = cljs.core.apply.call(null,func,cljs.core.rest.call(null,args));
var seq__37337 = cljs.core.seq.call(null,vec__37336);
var first__37338 = cljs.core.first.call(null,seq__37337);
var seq__37337__$1 = cljs.core.next.call(null,seq__37337);
var tag = first__37338;
var body = seq__37337__$1;
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,body))){
return cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag,cljs.core.merge.call(null,cljs.core.first.call(null,body),cljs.core.first.call(null,args))], null),cljs.core.rest.call(null,body));
} else {
return cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag,cljs.core.first.call(null,args)], null),body);
}
} else {
return cljs.core.apply.call(null,func,args);
}
};
var G__37339 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__37340__i = 0, G__37340__a = new Array(arguments.length -  0);
while (G__37340__i < G__37340__a.length) {G__37340__a[G__37340__i] = arguments[G__37340__i + 0]; ++G__37340__i;}
  args = new cljs.core.IndexedSeq(G__37340__a,0,null);
} 
return G__37339__delegate.call(this,args);};
G__37339.cljs$lang$maxFixedArity = 0;
G__37339.cljs$lang$applyTo = (function (arglist__37341){
var args = cljs.core.seq(arglist__37341);
return G__37339__delegate(args);
});
G__37339.cljs$core$IFn$_invoke$arity$variadic = G__37339__delegate;
return G__37339;
})()
;
});
sablono.core.update_arglists = (function sablono$core$update_arglists(arglists){
var iter__24200__auto__ = (function sablono$core$update_arglists_$_iter__37346(s__37347){
return (new cljs.core.LazySeq(null,(function (){
var s__37347__$1 = s__37347;
while(true){
var temp__5278__auto__ = cljs.core.seq.call(null,s__37347__$1);
if(temp__5278__auto__){
var s__37347__$2 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37347__$2)){
var c__24198__auto__ = cljs.core.chunk_first.call(null,s__37347__$2);
var size__24199__auto__ = cljs.core.count.call(null,c__24198__auto__);
var b__37349 = cljs.core.chunk_buffer.call(null,size__24199__auto__);
if((function (){var i__37348 = (0);
while(true){
if((i__37348 < size__24199__auto__)){
var args = cljs.core._nth.call(null,c__24198__auto__,i__37348);
cljs.core.chunk_append.call(null,b__37349,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)));

var G__37350 = (i__37348 + (1));
i__37348 = G__37350;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37349),sablono$core$update_arglists_$_iter__37346.call(null,cljs.core.chunk_rest.call(null,s__37347__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37349),null);
}
} else {
var args = cljs.core.first.call(null,s__37347__$2);
return cljs.core.cons.call(null,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)),sablono$core$update_arglists_$_iter__37346.call(null,cljs.core.rest.call(null,s__37347__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__24200__auto__.call(null,arglists);
});
/**
 * Include a list of external stylesheet files.
 */
sablono.core.include_css = (function sablono$core$include_css(var_args){
var args__24566__auto__ = [];
var len__24559__auto___37356 = arguments.length;
var i__24560__auto___37357 = (0);
while(true){
if((i__24560__auto___37357 < len__24559__auto___37356)){
args__24566__auto__.push((arguments[i__24560__auto___37357]));

var G__37358 = (i__24560__auto___37357 + (1));
i__24560__auto___37357 = G__37358;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((0) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((0)),(0),null)):null);
return sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic(argseq__24567__auto__);
});

sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic = (function (styles){
var iter__24200__auto__ = (function sablono$core$iter__37352(s__37353){
return (new cljs.core.LazySeq(null,(function (){
var s__37353__$1 = s__37353;
while(true){
var temp__5278__auto__ = cljs.core.seq.call(null,s__37353__$1);
if(temp__5278__auto__){
var s__37353__$2 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37353__$2)){
var c__24198__auto__ = cljs.core.chunk_first.call(null,s__37353__$2);
var size__24199__auto__ = cljs.core.count.call(null,c__24198__auto__);
var b__37355 = cljs.core.chunk_buffer.call(null,size__24199__auto__);
if((function (){var i__37354 = (0);
while(true){
if((i__37354 < size__24199__auto__)){
var style = cljs.core._nth.call(null,c__24198__auto__,i__37354);
cljs.core.chunk_append.call(null,b__37355,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null));

var G__37359 = (i__37354 + (1));
i__37354 = G__37359;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37355),sablono$core$iter__37352.call(null,cljs.core.chunk_rest.call(null,s__37353__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37355),null);
}
} else {
var style = cljs.core.first.call(null,s__37353__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null),sablono$core$iter__37352.call(null,cljs.core.rest.call(null,s__37353__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__24200__auto__.call(null,styles);
});

sablono.core.include_css.cljs$lang$maxFixedArity = (0);

sablono.core.include_css.cljs$lang$applyTo = (function (seq37351){
return sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq37351));
});

/**
 * Include the JavaScript library at `src`.
 */
sablono.core.include_js = (function sablono$core$include_js(src){
return goog.dom.appendChild(goog.dom.getDocument().body,goog.dom.createDom("script",({"src": src})));
});
/**
 * Include Facebook's React JavaScript library.
 */
sablono.core.include_react = (function sablono$core$include_react(){
return sablono.core.include_js.call(null,"http://fb.me/react-0.12.2.js");
});
/**
 * Wraps some content in a HTML hyperlink with the supplied URL.
 */
sablono.core.link_to37360 = (function sablono$core$link_to37360(var_args){
var args__24566__auto__ = [];
var len__24559__auto___37363 = arguments.length;
var i__24560__auto___37364 = (0);
while(true){
if((i__24560__auto___37364 < len__24559__auto___37363)){
args__24566__auto__.push((arguments[i__24560__auto___37364]));

var G__37365 = (i__24560__auto___37364 + (1));
i__24560__auto___37364 = G__37365;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((1) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((1)),(0),null)):null);
return sablono.core.link_to37360.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24567__auto__);
});

sablono.core.link_to37360.cljs$core$IFn$_invoke$arity$variadic = (function (url,content){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,url)], null),content], null);
});

sablono.core.link_to37360.cljs$lang$maxFixedArity = (1);

sablono.core.link_to37360.cljs$lang$applyTo = (function (seq37361){
var G__37362 = cljs.core.first.call(null,seq37361);
var seq37361__$1 = cljs.core.next.call(null,seq37361);
return sablono.core.link_to37360.cljs$core$IFn$_invoke$arity$variadic(G__37362,seq37361__$1);
});


sablono.core.link_to = sablono.core.wrap_attrs.call(null,sablono.core.link_to37360);
/**
 * Wraps some content in a HTML hyperlink with the supplied e-mail
 *   address. If no content provided use the e-mail address as content.
 */
sablono.core.mail_to37366 = (function sablono$core$mail_to37366(var_args){
var args__24566__auto__ = [];
var len__24559__auto___37373 = arguments.length;
var i__24560__auto___37374 = (0);
while(true){
if((i__24560__auto___37374 < len__24559__auto___37373)){
args__24566__auto__.push((arguments[i__24560__auto___37374]));

var G__37375 = (i__24560__auto___37374 + (1));
i__24560__auto___37374 = G__37375;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((1) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((1)),(0),null)):null);
return sablono.core.mail_to37366.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24567__auto__);
});

sablono.core.mail_to37366.cljs$core$IFn$_invoke$arity$variadic = (function (e_mail,p__37369){
var vec__37370 = p__37369;
var content = cljs.core.nth.call(null,vec__37370,(0),null);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),[cljs.core.str.cljs$core$IFn$_invoke$arity$1("mailto:"),cljs.core.str.cljs$core$IFn$_invoke$arity$1(e_mail)].join('')], null),(function (){var or__23338__auto__ = content;
if(cljs.core.truth_(or__23338__auto__)){
return or__23338__auto__;
} else {
return e_mail;
}
})()], null);
});

sablono.core.mail_to37366.cljs$lang$maxFixedArity = (1);

sablono.core.mail_to37366.cljs$lang$applyTo = (function (seq37367){
var G__37368 = cljs.core.first.call(null,seq37367);
var seq37367__$1 = cljs.core.next.call(null,seq37367);
return sablono.core.mail_to37366.cljs$core$IFn$_invoke$arity$variadic(G__37368,seq37367__$1);
});


sablono.core.mail_to = sablono.core.wrap_attrs.call(null,sablono.core.mail_to37366);
/**
 * Wrap a collection in an unordered list.
 */
sablono.core.unordered_list37376 = (function sablono$core$unordered_list37376(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ul","ul",-1349521403),(function (){var iter__24200__auto__ = (function sablono$core$unordered_list37376_$_iter__37381(s__37382){
return (new cljs.core.LazySeq(null,(function (){
var s__37382__$1 = s__37382;
while(true){
var temp__5278__auto__ = cljs.core.seq.call(null,s__37382__$1);
if(temp__5278__auto__){
var s__37382__$2 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37382__$2)){
var c__24198__auto__ = cljs.core.chunk_first.call(null,s__37382__$2);
var size__24199__auto__ = cljs.core.count.call(null,c__24198__auto__);
var b__37384 = cljs.core.chunk_buffer.call(null,size__24199__auto__);
if((function (){var i__37383 = (0);
while(true){
if((i__37383 < size__24199__auto__)){
var x = cljs.core._nth.call(null,c__24198__auto__,i__37383);
cljs.core.chunk_append.call(null,b__37384,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__37385 = (i__37383 + (1));
i__37383 = G__37385;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37384),sablono$core$unordered_list37376_$_iter__37381.call(null,cljs.core.chunk_rest.call(null,s__37382__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37384),null);
}
} else {
var x = cljs.core.first.call(null,s__37382__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$unordered_list37376_$_iter__37381.call(null,cljs.core.rest.call(null,s__37382__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__24200__auto__.call(null,coll);
})()], null);
});

sablono.core.unordered_list = sablono.core.wrap_attrs.call(null,sablono.core.unordered_list37376);
/**
 * Wrap a collection in an ordered list.
 */
sablono.core.ordered_list37386 = (function sablono$core$ordered_list37386(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ol","ol",932524051),(function (){var iter__24200__auto__ = (function sablono$core$ordered_list37386_$_iter__37391(s__37392){
return (new cljs.core.LazySeq(null,(function (){
var s__37392__$1 = s__37392;
while(true){
var temp__5278__auto__ = cljs.core.seq.call(null,s__37392__$1);
if(temp__5278__auto__){
var s__37392__$2 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37392__$2)){
var c__24198__auto__ = cljs.core.chunk_first.call(null,s__37392__$2);
var size__24199__auto__ = cljs.core.count.call(null,c__24198__auto__);
var b__37394 = cljs.core.chunk_buffer.call(null,size__24199__auto__);
if((function (){var i__37393 = (0);
while(true){
if((i__37393 < size__24199__auto__)){
var x = cljs.core._nth.call(null,c__24198__auto__,i__37393);
cljs.core.chunk_append.call(null,b__37394,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__37395 = (i__37393 + (1));
i__37393 = G__37395;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37394),sablono$core$ordered_list37386_$_iter__37391.call(null,cljs.core.chunk_rest.call(null,s__37392__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37394),null);
}
} else {
var x = cljs.core.first.call(null,s__37392__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$ordered_list37386_$_iter__37391.call(null,cljs.core.rest.call(null,s__37392__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__24200__auto__.call(null,coll);
})()], null);
});

sablono.core.ordered_list = sablono.core.wrap_attrs.call(null,sablono.core.ordered_list37386);
/**
 * Create an image element.
 */
sablono.core.image37396 = (function sablono$core$image37396(var_args){
var args37397 = [];
var len__24559__auto___37400 = arguments.length;
var i__24560__auto___37401 = (0);
while(true){
if((i__24560__auto___37401 < len__24559__auto___37400)){
args37397.push((arguments[i__24560__auto___37401]));

var G__37402 = (i__24560__auto___37401 + (1));
i__24560__auto___37401 = G__37402;
continue;
} else {
}
break;
}

var G__37399 = args37397.length;
switch (G__37399) {
case 1:
return sablono.core.image37396.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.image37396.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37397.length)].join('')));

}
});

sablono.core.image37396.cljs$core$IFn$_invoke$arity$1 = (function (src){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src)], null)], null);
});

sablono.core.image37396.cljs$core$IFn$_invoke$arity$2 = (function (src,alt){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src),new cljs.core.Keyword(null,"alt","alt",-3214426),alt], null)], null);
});

sablono.core.image37396.cljs$lang$maxFixedArity = 2;


sablono.core.image = sablono.core.wrap_attrs.call(null,sablono.core.image37396);
sablono.core._STAR_group_STAR_ = cljs.core.PersistentVector.EMPTY;
/**
 * Create a field name from the supplied argument the current field group.
 */
sablono.core.make_name = (function sablono$core$make_name(name){
return cljs.core.reduce.call(null,(function (p1__37404_SHARP_,p2__37405_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__37404_SHARP_),cljs.core.str.cljs$core$IFn$_invoke$arity$1("["),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p2__37405_SHARP_),cljs.core.str.cljs$core$IFn$_invoke$arity$1("]")].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Create a field id from the supplied argument and current field group.
 */
sablono.core.make_id = (function sablono$core$make_id(name){
return cljs.core.reduce.call(null,(function (p1__37406_SHARP_,p2__37407_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__37406_SHARP_),cljs.core.str.cljs$core$IFn$_invoke$arity$1("-"),cljs.core.str.cljs$core$IFn$_invoke$arity$1(p2__37407_SHARP_)].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Creates a new <input> element.
 */
sablono.core.input_field_STAR_ = (function sablono$core$input_field_STAR_(type,name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),type,new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__23338__auto__ = value;
if(cljs.core.truth_(or__23338__auto__)){
return or__23338__auto__;
} else {
return undefined;
}
})()], null)], null);
});
/**
 * Creates a color input field.
 */
sablono.core.color_field37408 = (function sablono$core$color_field37408(var_args){
var args37409 = [];
var len__24559__auto___37476 = arguments.length;
var i__24560__auto___37477 = (0);
while(true){
if((i__24560__auto___37477 < len__24559__auto___37476)){
args37409.push((arguments[i__24560__auto___37477]));

var G__37478 = (i__24560__auto___37477 + (1));
i__24560__auto___37477 = G__37478;
continue;
} else {
}
break;
}

var G__37411 = args37409.length;
switch (G__37411) {
case 1:
return sablono.core.color_field37408.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.color_field37408.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37409.length)].join('')));

}
});

sablono.core.color_field37408.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.color_field37408.call(null,name__37323__auto__,null);
});

sablono.core.color_field37408.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"color","color",-1642760596,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.color_field37408.cljs$lang$maxFixedArity = 2;


sablono.core.color_field = sablono.core.wrap_attrs.call(null,sablono.core.color_field37408);

/**
 * Creates a date input field.
 */
sablono.core.date_field37412 = (function sablono$core$date_field37412(var_args){
var args37413 = [];
var len__24559__auto___37480 = arguments.length;
var i__24560__auto___37481 = (0);
while(true){
if((i__24560__auto___37481 < len__24559__auto___37480)){
args37413.push((arguments[i__24560__auto___37481]));

var G__37482 = (i__24560__auto___37481 + (1));
i__24560__auto___37481 = G__37482;
continue;
} else {
}
break;
}

var G__37415 = args37413.length;
switch (G__37415) {
case 1:
return sablono.core.date_field37412.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.date_field37412.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37413.length)].join('')));

}
});

sablono.core.date_field37412.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.date_field37412.call(null,name__37323__auto__,null);
});

sablono.core.date_field37412.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"date","date",177097065,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.date_field37412.cljs$lang$maxFixedArity = 2;


sablono.core.date_field = sablono.core.wrap_attrs.call(null,sablono.core.date_field37412);

/**
 * Creates a datetime input field.
 */
sablono.core.datetime_field37416 = (function sablono$core$datetime_field37416(var_args){
var args37417 = [];
var len__24559__auto___37484 = arguments.length;
var i__24560__auto___37485 = (0);
while(true){
if((i__24560__auto___37485 < len__24559__auto___37484)){
args37417.push((arguments[i__24560__auto___37485]));

var G__37486 = (i__24560__auto___37485 + (1));
i__24560__auto___37485 = G__37486;
continue;
} else {
}
break;
}

var G__37419 = args37417.length;
switch (G__37419) {
case 1:
return sablono.core.datetime_field37416.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_field37416.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37417.length)].join('')));

}
});

sablono.core.datetime_field37416.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.datetime_field37416.call(null,name__37323__auto__,null);
});

sablono.core.datetime_field37416.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime","datetime",2135207229,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.datetime_field37416.cljs$lang$maxFixedArity = 2;


sablono.core.datetime_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_field37416);

/**
 * Creates a datetime-local input field.
 */
sablono.core.datetime_local_field37420 = (function sablono$core$datetime_local_field37420(var_args){
var args37421 = [];
var len__24559__auto___37488 = arguments.length;
var i__24560__auto___37489 = (0);
while(true){
if((i__24560__auto___37489 < len__24559__auto___37488)){
args37421.push((arguments[i__24560__auto___37489]));

var G__37490 = (i__24560__auto___37489 + (1));
i__24560__auto___37489 = G__37490;
continue;
} else {
}
break;
}

var G__37423 = args37421.length;
switch (G__37423) {
case 1:
return sablono.core.datetime_local_field37420.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_local_field37420.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37421.length)].join('')));

}
});

sablono.core.datetime_local_field37420.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.datetime_local_field37420.call(null,name__37323__auto__,null);
});

sablono.core.datetime_local_field37420.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime-local","datetime-local",-507312697,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.datetime_local_field37420.cljs$lang$maxFixedArity = 2;


sablono.core.datetime_local_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_local_field37420);

/**
 * Creates a email input field.
 */
sablono.core.email_field37424 = (function sablono$core$email_field37424(var_args){
var args37425 = [];
var len__24559__auto___37492 = arguments.length;
var i__24560__auto___37493 = (0);
while(true){
if((i__24560__auto___37493 < len__24559__auto___37492)){
args37425.push((arguments[i__24560__auto___37493]));

var G__37494 = (i__24560__auto___37493 + (1));
i__24560__auto___37493 = G__37494;
continue;
} else {
}
break;
}

var G__37427 = args37425.length;
switch (G__37427) {
case 1:
return sablono.core.email_field37424.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.email_field37424.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37425.length)].join('')));

}
});

sablono.core.email_field37424.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.email_field37424.call(null,name__37323__auto__,null);
});

sablono.core.email_field37424.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"email","email",-1238619063,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.email_field37424.cljs$lang$maxFixedArity = 2;


sablono.core.email_field = sablono.core.wrap_attrs.call(null,sablono.core.email_field37424);

/**
 * Creates a file input field.
 */
sablono.core.file_field37428 = (function sablono$core$file_field37428(var_args){
var args37429 = [];
var len__24559__auto___37496 = arguments.length;
var i__24560__auto___37497 = (0);
while(true){
if((i__24560__auto___37497 < len__24559__auto___37496)){
args37429.push((arguments[i__24560__auto___37497]));

var G__37498 = (i__24560__auto___37497 + (1));
i__24560__auto___37497 = G__37498;
continue;
} else {
}
break;
}

var G__37431 = args37429.length;
switch (G__37431) {
case 1:
return sablono.core.file_field37428.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.file_field37428.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37429.length)].join('')));

}
});

sablono.core.file_field37428.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.file_field37428.call(null,name__37323__auto__,null);
});

sablono.core.file_field37428.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"file","file",370885649,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.file_field37428.cljs$lang$maxFixedArity = 2;


sablono.core.file_field = sablono.core.wrap_attrs.call(null,sablono.core.file_field37428);

/**
 * Creates a hidden input field.
 */
sablono.core.hidden_field37432 = (function sablono$core$hidden_field37432(var_args){
var args37433 = [];
var len__24559__auto___37500 = arguments.length;
var i__24560__auto___37501 = (0);
while(true){
if((i__24560__auto___37501 < len__24559__auto___37500)){
args37433.push((arguments[i__24560__auto___37501]));

var G__37502 = (i__24560__auto___37501 + (1));
i__24560__auto___37501 = G__37502;
continue;
} else {
}
break;
}

var G__37435 = args37433.length;
switch (G__37435) {
case 1:
return sablono.core.hidden_field37432.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.hidden_field37432.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37433.length)].join('')));

}
});

sablono.core.hidden_field37432.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.hidden_field37432.call(null,name__37323__auto__,null);
});

sablono.core.hidden_field37432.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"hidden","hidden",1328025435,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.hidden_field37432.cljs$lang$maxFixedArity = 2;


sablono.core.hidden_field = sablono.core.wrap_attrs.call(null,sablono.core.hidden_field37432);

/**
 * Creates a month input field.
 */
sablono.core.month_field37436 = (function sablono$core$month_field37436(var_args){
var args37437 = [];
var len__24559__auto___37504 = arguments.length;
var i__24560__auto___37505 = (0);
while(true){
if((i__24560__auto___37505 < len__24559__auto___37504)){
args37437.push((arguments[i__24560__auto___37505]));

var G__37506 = (i__24560__auto___37505 + (1));
i__24560__auto___37505 = G__37506;
continue;
} else {
}
break;
}

var G__37439 = args37437.length;
switch (G__37439) {
case 1:
return sablono.core.month_field37436.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.month_field37436.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37437.length)].join('')));

}
});

sablono.core.month_field37436.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.month_field37436.call(null,name__37323__auto__,null);
});

sablono.core.month_field37436.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"month","month",-319717006,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.month_field37436.cljs$lang$maxFixedArity = 2;


sablono.core.month_field = sablono.core.wrap_attrs.call(null,sablono.core.month_field37436);

/**
 * Creates a number input field.
 */
sablono.core.number_field37440 = (function sablono$core$number_field37440(var_args){
var args37441 = [];
var len__24559__auto___37508 = arguments.length;
var i__24560__auto___37509 = (0);
while(true){
if((i__24560__auto___37509 < len__24559__auto___37508)){
args37441.push((arguments[i__24560__auto___37509]));

var G__37510 = (i__24560__auto___37509 + (1));
i__24560__auto___37509 = G__37510;
continue;
} else {
}
break;
}

var G__37443 = args37441.length;
switch (G__37443) {
case 1:
return sablono.core.number_field37440.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.number_field37440.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37441.length)].join('')));

}
});

sablono.core.number_field37440.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.number_field37440.call(null,name__37323__auto__,null);
});

sablono.core.number_field37440.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"number","number",-1084057331,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.number_field37440.cljs$lang$maxFixedArity = 2;


sablono.core.number_field = sablono.core.wrap_attrs.call(null,sablono.core.number_field37440);

/**
 * Creates a password input field.
 */
sablono.core.password_field37444 = (function sablono$core$password_field37444(var_args){
var args37445 = [];
var len__24559__auto___37512 = arguments.length;
var i__24560__auto___37513 = (0);
while(true){
if((i__24560__auto___37513 < len__24559__auto___37512)){
args37445.push((arguments[i__24560__auto___37513]));

var G__37514 = (i__24560__auto___37513 + (1));
i__24560__auto___37513 = G__37514;
continue;
} else {
}
break;
}

var G__37447 = args37445.length;
switch (G__37447) {
case 1:
return sablono.core.password_field37444.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.password_field37444.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37445.length)].join('')));

}
});

sablono.core.password_field37444.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.password_field37444.call(null,name__37323__auto__,null);
});

sablono.core.password_field37444.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"password","password",2057553998,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.password_field37444.cljs$lang$maxFixedArity = 2;


sablono.core.password_field = sablono.core.wrap_attrs.call(null,sablono.core.password_field37444);

/**
 * Creates a range input field.
 */
sablono.core.range_field37448 = (function sablono$core$range_field37448(var_args){
var args37449 = [];
var len__24559__auto___37516 = arguments.length;
var i__24560__auto___37517 = (0);
while(true){
if((i__24560__auto___37517 < len__24559__auto___37516)){
args37449.push((arguments[i__24560__auto___37517]));

var G__37518 = (i__24560__auto___37517 + (1));
i__24560__auto___37517 = G__37518;
continue;
} else {
}
break;
}

var G__37451 = args37449.length;
switch (G__37451) {
case 1:
return sablono.core.range_field37448.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.range_field37448.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37449.length)].join('')));

}
});

sablono.core.range_field37448.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.range_field37448.call(null,name__37323__auto__,null);
});

sablono.core.range_field37448.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"range","range",-1014743483,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.range_field37448.cljs$lang$maxFixedArity = 2;


sablono.core.range_field = sablono.core.wrap_attrs.call(null,sablono.core.range_field37448);

/**
 * Creates a search input field.
 */
sablono.core.search_field37452 = (function sablono$core$search_field37452(var_args){
var args37453 = [];
var len__24559__auto___37520 = arguments.length;
var i__24560__auto___37521 = (0);
while(true){
if((i__24560__auto___37521 < len__24559__auto___37520)){
args37453.push((arguments[i__24560__auto___37521]));

var G__37522 = (i__24560__auto___37521 + (1));
i__24560__auto___37521 = G__37522;
continue;
} else {
}
break;
}

var G__37455 = args37453.length;
switch (G__37455) {
case 1:
return sablono.core.search_field37452.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.search_field37452.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37453.length)].join('')));

}
});

sablono.core.search_field37452.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.search_field37452.call(null,name__37323__auto__,null);
});

sablono.core.search_field37452.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"search","search",-1089495947,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.search_field37452.cljs$lang$maxFixedArity = 2;


sablono.core.search_field = sablono.core.wrap_attrs.call(null,sablono.core.search_field37452);

/**
 * Creates a tel input field.
 */
sablono.core.tel_field37456 = (function sablono$core$tel_field37456(var_args){
var args37457 = [];
var len__24559__auto___37524 = arguments.length;
var i__24560__auto___37525 = (0);
while(true){
if((i__24560__auto___37525 < len__24559__auto___37524)){
args37457.push((arguments[i__24560__auto___37525]));

var G__37526 = (i__24560__auto___37525 + (1));
i__24560__auto___37525 = G__37526;
continue;
} else {
}
break;
}

var G__37459 = args37457.length;
switch (G__37459) {
case 1:
return sablono.core.tel_field37456.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.tel_field37456.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37457.length)].join('')));

}
});

sablono.core.tel_field37456.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.tel_field37456.call(null,name__37323__auto__,null);
});

sablono.core.tel_field37456.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"tel","tel",1864669686,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.tel_field37456.cljs$lang$maxFixedArity = 2;


sablono.core.tel_field = sablono.core.wrap_attrs.call(null,sablono.core.tel_field37456);

/**
 * Creates a text input field.
 */
sablono.core.text_field37460 = (function sablono$core$text_field37460(var_args){
var args37461 = [];
var len__24559__auto___37528 = arguments.length;
var i__24560__auto___37529 = (0);
while(true){
if((i__24560__auto___37529 < len__24559__auto___37528)){
args37461.push((arguments[i__24560__auto___37529]));

var G__37530 = (i__24560__auto___37529 + (1));
i__24560__auto___37529 = G__37530;
continue;
} else {
}
break;
}

var G__37463 = args37461.length;
switch (G__37463) {
case 1:
return sablono.core.text_field37460.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_field37460.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37461.length)].join('')));

}
});

sablono.core.text_field37460.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.text_field37460.call(null,name__37323__auto__,null);
});

sablono.core.text_field37460.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"text","text",-150030170,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.text_field37460.cljs$lang$maxFixedArity = 2;


sablono.core.text_field = sablono.core.wrap_attrs.call(null,sablono.core.text_field37460);

/**
 * Creates a time input field.
 */
sablono.core.time_field37464 = (function sablono$core$time_field37464(var_args){
var args37465 = [];
var len__24559__auto___37532 = arguments.length;
var i__24560__auto___37533 = (0);
while(true){
if((i__24560__auto___37533 < len__24559__auto___37532)){
args37465.push((arguments[i__24560__auto___37533]));

var G__37534 = (i__24560__auto___37533 + (1));
i__24560__auto___37533 = G__37534;
continue;
} else {
}
break;
}

var G__37467 = args37465.length;
switch (G__37467) {
case 1:
return sablono.core.time_field37464.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.time_field37464.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37465.length)].join('')));

}
});

sablono.core.time_field37464.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.time_field37464.call(null,name__37323__auto__,null);
});

sablono.core.time_field37464.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"time","time",-1268547887,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.time_field37464.cljs$lang$maxFixedArity = 2;


sablono.core.time_field = sablono.core.wrap_attrs.call(null,sablono.core.time_field37464);

/**
 * Creates a url input field.
 */
sablono.core.url_field37468 = (function sablono$core$url_field37468(var_args){
var args37469 = [];
var len__24559__auto___37536 = arguments.length;
var i__24560__auto___37537 = (0);
while(true){
if((i__24560__auto___37537 < len__24559__auto___37536)){
args37469.push((arguments[i__24560__auto___37537]));

var G__37538 = (i__24560__auto___37537 + (1));
i__24560__auto___37537 = G__37538;
continue;
} else {
}
break;
}

var G__37471 = args37469.length;
switch (G__37471) {
case 1:
return sablono.core.url_field37468.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.url_field37468.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37469.length)].join('')));

}
});

sablono.core.url_field37468.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.url_field37468.call(null,name__37323__auto__,null);
});

sablono.core.url_field37468.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"url","url",1916828573,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.url_field37468.cljs$lang$maxFixedArity = 2;


sablono.core.url_field = sablono.core.wrap_attrs.call(null,sablono.core.url_field37468);

/**
 * Creates a week input field.
 */
sablono.core.week_field37472 = (function sablono$core$week_field37472(var_args){
var args37473 = [];
var len__24559__auto___37540 = arguments.length;
var i__24560__auto___37541 = (0);
while(true){
if((i__24560__auto___37541 < len__24559__auto___37540)){
args37473.push((arguments[i__24560__auto___37541]));

var G__37542 = (i__24560__auto___37541 + (1));
i__24560__auto___37541 = G__37542;
continue;
} else {
}
break;
}

var G__37475 = args37473.length;
switch (G__37475) {
case 1:
return sablono.core.week_field37472.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.week_field37472.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37473.length)].join('')));

}
});

sablono.core.week_field37472.cljs$core$IFn$_invoke$arity$1 = (function (name__37323__auto__){
return sablono.core.week_field37472.call(null,name__37323__auto__,null);
});

sablono.core.week_field37472.cljs$core$IFn$_invoke$arity$2 = (function (name__37323__auto__,value__37324__auto__){
return sablono.core.input_field_STAR_.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"week","week",314058249,null))].join(''),name__37323__auto__,value__37324__auto__);
});

sablono.core.week_field37472.cljs$lang$maxFixedArity = 2;


sablono.core.week_field = sablono.core.wrap_attrs.call(null,sablono.core.week_field37472);
sablono.core.file_upload = sablono.core.file_field;
/**
 * Creates a check box.
 */
sablono.core.check_box37544 = (function sablono$core$check_box37544(var_args){
var args37545 = [];
var len__24559__auto___37548 = arguments.length;
var i__24560__auto___37549 = (0);
while(true){
if((i__24560__auto___37549 < len__24559__auto___37548)){
args37545.push((arguments[i__24560__auto___37549]));

var G__37550 = (i__24560__auto___37549 + (1));
i__24560__auto___37549 = G__37550;
continue;
} else {
}
break;
}

var G__37547 = args37545.length;
switch (G__37547) {
case 1:
return sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37545.length)].join('')));

}
});

sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$1 = (function (name){
return sablono.core.check_box37544.call(null,name,null);
});

sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$2 = (function (name,checked_QMARK_){
return sablono.core.check_box37544.call(null,name,checked_QMARK_,"true");
});

sablono.core.check_box37544.cljs$core$IFn$_invoke$arity$3 = (function (name,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"checkbox",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__23338__auto__ = value;
if(cljs.core.truth_(or__23338__auto__)){
return or__23338__auto__;
} else {
return undefined;
}
})(),new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.check_box37544.cljs$lang$maxFixedArity = 3;


sablono.core.check_box = sablono.core.wrap_attrs.call(null,sablono.core.check_box37544);
/**
 * Creates a radio button.
 */
sablono.core.radio_button37552 = (function sablono$core$radio_button37552(var_args){
var args37553 = [];
var len__24559__auto___37556 = arguments.length;
var i__24560__auto___37557 = (0);
while(true){
if((i__24560__auto___37557 < len__24559__auto___37556)){
args37553.push((arguments[i__24560__auto___37557]));

var G__37558 = (i__24560__auto___37557 + (1));
i__24560__auto___37557 = G__37558;
continue;
} else {
}
break;
}

var G__37555 = args37553.length;
switch (G__37555) {
case 1:
return sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37553.length)].join('')));

}
});

sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$1 = (function (group){
return sablono.core.radio_button37552.call(null,group,null);
});

sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$2 = (function (group,checked_QMARK_){
return sablono.core.radio_button37552.call(null,group,checked_QMARK_,"true");
});

sablono.core.radio_button37552.cljs$core$IFn$_invoke$arity$3 = (function (group,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"radio",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,group),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(sablono.util.as_str.call(null,group)),cljs.core.str.cljs$core$IFn$_invoke$arity$1("-"),cljs.core.str.cljs$core$IFn$_invoke$arity$1(sablono.util.as_str.call(null,value))].join('')),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__23338__auto__ = value;
if(cljs.core.truth_(or__23338__auto__)){
return or__23338__auto__;
} else {
return undefined;
}
})(),new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.radio_button37552.cljs$lang$maxFixedArity = 3;


sablono.core.radio_button = sablono.core.wrap_attrs.call(null,sablono.core.radio_button37552);
sablono.core.hash_key = (function sablono$core$hash_key(x){
return goog.string.hashCode(cljs.core.pr_str.call(null,x));
});
/**
 * Creates a seq of option tags from a collection.
 */
sablono.core.select_options37560 = (function sablono$core$select_options37560(coll){
var iter__24200__auto__ = (function sablono$core$select_options37560_$_iter__37577(s__37578){
return (new cljs.core.LazySeq(null,(function (){
var s__37578__$1 = s__37578;
while(true){
var temp__5278__auto__ = cljs.core.seq.call(null,s__37578__$1);
if(temp__5278__auto__){
var s__37578__$2 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37578__$2)){
var c__24198__auto__ = cljs.core.chunk_first.call(null,s__37578__$2);
var size__24199__auto__ = cljs.core.count.call(null,c__24198__auto__);
var b__37580 = cljs.core.chunk_buffer.call(null,size__24199__auto__);
if((function (){var i__37579 = (0);
while(true){
if((i__37579 < size__24199__auto__)){
var x = cljs.core._nth.call(null,c__24198__auto__,i__37579);
cljs.core.chunk_append.call(null,b__37580,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__37587 = x;
var text = cljs.core.nth.call(null,vec__37587,(0),null);
var val = cljs.core.nth.call(null,vec__37587,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__37587,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono.core.select_options37560.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)));

var G__37593 = (i__37579 + (1));
i__37579 = G__37593;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37580),sablono$core$select_options37560_$_iter__37577.call(null,cljs.core.chunk_rest.call(null,s__37578__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37580),null);
}
} else {
var x = cljs.core.first.call(null,s__37578__$2);
return cljs.core.cons.call(null,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__37590 = x;
var text = cljs.core.nth.call(null,vec__37590,(0),null);
var val = cljs.core.nth.call(null,vec__37590,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__37590,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono.core.select_options37560.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)),sablono$core$select_options37560_$_iter__37577.call(null,cljs.core.rest.call(null,s__37578__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__24200__auto__.call(null,coll);
});

sablono.core.select_options = sablono.core.wrap_attrs.call(null,sablono.core.select_options37560);
/**
 * Creates a drop-down box using the <select> tag.
 */
sablono.core.drop_down37594 = (function sablono$core$drop_down37594(var_args){
var args37595 = [];
var len__24559__auto___37598 = arguments.length;
var i__24560__auto___37599 = (0);
while(true){
if((i__24560__auto___37599 < len__24559__auto___37598)){
args37595.push((arguments[i__24560__auto___37599]));

var G__37600 = (i__24560__auto___37599 + (1));
i__24560__auto___37599 = G__37600;
continue;
} else {
}
break;
}

var G__37597 = args37595.length;
switch (G__37597) {
case 2:
return sablono.core.drop_down37594.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.drop_down37594.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37595.length)].join('')));

}
});

sablono.core.drop_down37594.cljs$core$IFn$_invoke$arity$2 = (function (name,options){
return sablono.core.drop_down37594.call(null,name,options,null);
});

sablono.core.drop_down37594.cljs$core$IFn$_invoke$arity$3 = (function (name,options,selected){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null),sablono.core.select_options.call(null,options,selected)], null);
});

sablono.core.drop_down37594.cljs$lang$maxFixedArity = 3;


sablono.core.drop_down = sablono.core.wrap_attrs.call(null,sablono.core.drop_down37594);
/**
 * Creates a text area element.
 */
sablono.core.text_area37602 = (function sablono$core$text_area37602(var_args){
var args37603 = [];
var len__24559__auto___37606 = arguments.length;
var i__24560__auto___37607 = (0);
while(true){
if((i__24560__auto___37607 < len__24559__auto___37606)){
args37603.push((arguments[i__24560__auto___37607]));

var G__37608 = (i__24560__auto___37607 + (1));
i__24560__auto___37607 = G__37608;
continue;
} else {
}
break;
}

var G__37605 = args37603.length;
switch (G__37605) {
case 1:
return sablono.core.text_area37602.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_area37602.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args37603.length)].join('')));

}
});

sablono.core.text_area37602.cljs$core$IFn$_invoke$arity$1 = (function (name){
return sablono.core.text_area37602.call(null,name,null);
});

sablono.core.text_area37602.cljs$core$IFn$_invoke$arity$2 = (function (name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"textarea","textarea",-650375824),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__23338__auto__ = value;
if(cljs.core.truth_(or__23338__auto__)){
return or__23338__auto__;
} else {
return undefined;
}
})()], null)], null);
});

sablono.core.text_area37602.cljs$lang$maxFixedArity = 2;


sablono.core.text_area = sablono.core.wrap_attrs.call(null,sablono.core.text_area37602);
/**
 * Creates a label for an input field with the supplied name.
 */
sablono.core.label37610 = (function sablono$core$label37610(name,text){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"label","label",1718410804),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"htmlFor","htmlFor",-1050291720),sablono.core.make_id.call(null,name)], null),text], null);
});

sablono.core.label = sablono.core.wrap_attrs.call(null,sablono.core.label37610);
/**
 * Creates a submit button.
 */
sablono.core.submit_button37611 = (function sablono$core$submit_button37611(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"submit",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.submit_button = sablono.core.wrap_attrs.call(null,sablono.core.submit_button37611);
/**
 * Creates a form reset button.
 */
sablono.core.reset_button37612 = (function sablono$core$reset_button37612(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"reset",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.reset_button = sablono.core.wrap_attrs.call(null,sablono.core.reset_button37612);
/**
 * Create a form that points to a particular method and route.
 *   e.g. (form-to [:put "/post"]
 *       ...)
 */
sablono.core.form_to37613 = (function sablono$core$form_to37613(var_args){
var args__24566__auto__ = [];
var len__24559__auto___37620 = arguments.length;
var i__24560__auto___37621 = (0);
while(true){
if((i__24560__auto___37621 < len__24559__auto___37620)){
args__24566__auto__.push((arguments[i__24560__auto___37621]));

var G__37622 = (i__24560__auto___37621 + (1));
i__24560__auto___37621 = G__37622;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((1) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((1)),(0),null)):null);
return sablono.core.form_to37613.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24567__auto__);
});

sablono.core.form_to37613.cljs$core$IFn$_invoke$arity$variadic = (function (p__37616,body){
var vec__37617 = p__37616;
var method = cljs.core.nth.call(null,vec__37617,(0),null);
var action = cljs.core.nth.call(null,vec__37617,(1),null);
var method_str = clojure.string.upper_case.call(null,cljs.core.name.call(null,method));
var action_uri = sablono.util.to_uri.call(null,action);
return cljs.core.vec.call(null,cljs.core.concat.call(null,((cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"get","get",1683182755),null,new cljs.core.Keyword(null,"post","post",269697687),null], null), null),method))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),method_str,new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null)], null):new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),"POST",new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null),sablono.core.hidden_field.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),(3735928559)], null),"_method",method_str)], null)),body));
});

sablono.core.form_to37613.cljs$lang$maxFixedArity = (1);

sablono.core.form_to37613.cljs$lang$applyTo = (function (seq37614){
var G__37615 = cljs.core.first.call(null,seq37614);
var seq37614__$1 = cljs.core.next.call(null,seq37614);
return sablono.core.form_to37613.cljs$core$IFn$_invoke$arity$variadic(G__37615,seq37614__$1);
});


sablono.core.form_to = sablono.core.wrap_attrs.call(null,sablono.core.form_to37613);
